/* C code produced by gperf version 2.1 (K&R C version) */
/* Command-line: gperf -g -acCptT -S 1 -k 1,2,$ -N acap_token_lookup token.acap.gperf  */

 /* token.acap.gperf - acap token recognizer
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#include <config.h>
#include <string.h>
#include "../util/str.h"
#include "parse.acap.h"
#include "token.acap.h"

/* It's pretty gratuitous to use gperf for this, especially
 * since I think this is going to be an utterly negligable
 * part of the running time of the server, but on the other hand,
 * it's somehow relaxing to take a break and write some code The Right Way.
 */


#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 14
#define MIN_HASH_VALUE 3
#define MAX_HASH_VALUE 102
/*
   42 keywords
  100 is the maximum key range
*/

#ifdef __GNUC__
inline
#endif
static int
hash (register const char *str, register int len)
{
  static const unsigned char hash_table[] =
    {
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
     102, 102, 102, 102, 102, 102, 102,   0, 102,  20,
      10,   0,   5,  60,  15,  50, 102, 102,   0,  20,
       5,  30,  30,  10,  35,   0,   0,  30,   5, 102,
      20,   0, 102, 102, 102, 102, 102, 102,
  };
  return len + hash_table[str[1] & 0x7F] + hash_table[str[0] & 0x7F] + hash_table[str[len - 1] & 0x7F];
}

#ifdef __GNUC__
inline
#endif
const struct acap_token_s *
acap_token_lookup (register const char *str, register int len)
{

  static const struct acap_token_s  wordlist[] =
    {
      {"all", 		ALL},
      {"store", 		STORE},
      {"setacl", 		SETACL},
      {"attribute", 	ATTRIBUTE},
      {"value", 		VALUE},
      {"enumerate", 	ENUMERATE},
      {"equal", 		EQUAL},
      {"default", 	DEFAULT},
      {"and", 		AND},
      {"deleteacl", 	DELETEACL},
      {"search", 		SEARCH},
      {"deletedsince", 	DELETEDSINCE},
      {"acl", 		ACL},
      {"hardlimit", 	HARDLIMIT},
      {"myrights", 	MYRIGHTS},
      {"depth", 		DEPTH},
      {"makecontext", 	MAKECONTEXT},
      {"sort", 		SORT},
      {"logout", 		LOGOUT},
      {"not", 		NOT},
      {"range", 		RANGE},
      {"notify", 		NOTIFY},
      {"authenticate", 	AUTHENTICATE},
      {"nocreate", 	NOCREATE},
      {"noinherit", 	NOINHERIT},
      {"return", 		RETURN},
      {"unchangedsince", 	UNCHANGEDSINCE},
      {"freecontext", 	FREECONTEXT},
      {"size", 		SIZE},
      {"limit", 		LIMIT},
      {"compare", 	COMPARE},
      {"nil", 		NIL},
      {"listrights", 	LISTRIGHTS},
      {"content-type", 	CONTENT_TYPE},
      {"comparestrict", 	COMPARESTRICT},
      {"lang", 		LANG},
      {"getquota", 	GETQUOTA},
      {"noop", 		NOOP},
      {"updatecontext", 	UPDATECONTEXT},
      {"prefix", 		PREFIX},
      {"substring", 	SUBSTRING},
      {"or", 		OR},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          if (key <= 102)
            {
              const struct acap_token_s  *resword; 

              switch (key - 3)
                {
                case    0:
                  resword = &wordlist[0]; break;
                case    2:
                  resword = &wordlist[1]; break;
                case    3:
                  resword = &wordlist[2]; break;
                case    6:
                  resword = &wordlist[3]; break;
                case    7:
                  resword = &wordlist[4]; break;
                case   11:
                  resword = &wordlist[5]; break;
                case   12:
                  resword = &wordlist[6]; break;
                case   14:
                  resword = &wordlist[7]; break;
                case   15:
                  resword = &wordlist[8]; break;
                case   16:
                  resword = &wordlist[9]; break;
                case   18:
                  resword = &wordlist[10]; break;
                case   19:
                  resword = &wordlist[11]; break;
                case   20:
                  resword = &wordlist[12]; break;
                case   21:
                  resword = &wordlist[13]; break;
                case   25:
                  resword = &wordlist[14]; break;
                case   27:
                  resword = &wordlist[15]; break;
                case   28:
                  resword = &wordlist[16]; break;
                case   31:
                  resword = &wordlist[17]; break;
                case   33:
                  resword = &wordlist[18]; break;
                case   35:
                  resword = &wordlist[19]; break;
                case   37:
                  resword = &wordlist[20]; break;
                case   38:
                  resword = &wordlist[21]; break;
                case   39:
                  resword = &wordlist[22]; break;
                case   40:
                  resword = &wordlist[23]; break;
                case   41:
                  resword = &wordlist[24]; break;
                case   43:
                  resword = &wordlist[25]; break;
                case   46:
                  resword = &wordlist[26]; break;
                case   48:
                  resword = &wordlist[27]; break;
                case   51:
                  resword = &wordlist[28]; break;
                case   52:
                  resword = &wordlist[29]; break;
                case   54:
                  resword = &wordlist[30]; break;
                case   55:
                  resword = &wordlist[31]; break;
                case   57:
                  resword = &wordlist[32]; break;
                case   59:
                  resword = &wordlist[33]; break;
                case   60:
                  resword = &wordlist[34]; break;
                case   61:
                  resword = &wordlist[35]; break;
                case   65:
                  resword = &wordlist[36]; break;
                case   66:
                  resword = &wordlist[37]; break;
                case   70:
                  resword = &wordlist[38]; break;
                case   88:
                  resword = &wordlist[39]; break;
                case   96:
                  resword = &wordlist[40]; break;
                case   99:
                  resword = &wordlist[41]; break;
                default: return 0;
                }
              if (*str == *resword->name && !strncmp (str + 1, resword->name + 1, len - 1))
                return resword;
              return 0;
            }
         }
    }
  return 0;
}
