dnl pthreads.m4--pthreads setup macro
dnl Rob Earhart

AC_DEFUN(CMU_PTHREADS, [
  AC_REQUIRE([AC_CANONICAL_HOST])
  case "$host_os" in
  osf4*)
	if test "$GNU" != yes; then
	  CFLAGS="-pthread $CFLAGS"
	else
	  CFLAGS="-Wl,-pthread $CFLAGS"
	fi
	;;
  osf3*)
	if test "$GNU" != yes; then
	  CFLAGS="-threads $CFLAGS"
	else
	  CFLAGS="-Wl,-threads $CFLAGS"
	fi
	;;
  esac
  cmu_save_LIBS="$LIBS"
  AC_CHECK_FUNC(pthread_create,LIB_PTHREAD="",
    AC_CHECK_LIB(pthread, pthread_create,LIB_PTHREAD="-lpthread",
      AC_CHECK_LIB(pthreads, pthread_create,LIB_PTHREAD="-lpthreads",
        AC_CHECK_LIB(c_r, pthread_create,LIB_PTHREAD="-lc_r",
          AC_CHECK_LIB(threads, pthread_create,LIB_PTHREAD="-lthreads",
            AC_ERROR([Can't compile without pthreads]))))))
  LIBS="$cmu_save_LIBS"
  AC_SUBST(LIB_PTHREAD)
  AC_DEFINE(_REENTRANT)
  case "$host_os" in
  solaris2*)
	AC_DEFINE(_POSIX_PTHREAD_SEMANTICS)
	AC_DEFINE(__EXTENSIONS__)
	;;
  irix6*)
	AC_DEFINE(_SGI_REENTRANT_FUNCTIONS)
	;;
  esac
])

