/* sock.h - socket interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef SOCK_H
#define SOCK_H

#include <netinet/in.h>

typedef
result_t sock_handler_t(struct sockaddr_in * addr,
			int fd,
			void *rock);

typedef struct sock_s sock_t;

/* This binds the port, starts listening on it, and calls the
 * specified handler for each incoming connection. */
extern result_t
sock_open(const char *port_name,
	  short default_port,
	  sock_handler_t * handler,
	  void *rock,
	  sock_t ** socket);

/* This closes down the port, and stops listening on it. */
extern result_t sock_close(sock_t ** socket);

#endif				/* SOCK_H */
