/* queue.h - queue interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef QUEUE_H
#define QUEUE_H

/* This is just a simple queue interface.
 * No synchronization is supplied.
 */

typedef struct queue_node_s queue_node_t;

/* I'd call this a queue_t, but that's used in
 * sys/stream.h on Solaris.  That's what I get for using foo_t when
 * Posix explicitly reserves it... */
typedef struct {
  queue_node_t   *front,
                 *back;
}               q_t;

extern          result_t queue_init(q_t * queue);

extern result_t queue_destroy(q_t * queue);

extern result_t
queue_push(q_t * queue,
	   void *data);

/* queue_pop returns QUEUE_EMPTY if the queue is empty */
extern result_t
queue_pop(q_t * queue,
	  void **data);

#define queue_ISEMPTY(q) ((q)->front ? FALSE : TRUE)
#endif				/* QUEUE_H */
